/**
 * @file Aux.c
 * @author Hugo Tavares nº 27764 (hugo.tavares@ua.pt)
 * @brief Ficheiro que contém funções ou rotinas auxiliares
 * 
 * Este ficheiro contém as funções e/ou rotinas que são chamadas por outros ficheiros
 */

#define _AUX_

#include "SALbot_Interface.h"

/** 
*  @fn void Actualiza_estado_SAL1(void)
 *  Função que actualiza na interface os widgets activos para o estado actual do SALbot1
 */
void Actualiza_estado_SAL1(void)
{
       char lbl_mode[30];
       GtkWidget *bt_modo = glade_xml_get_widget(xmlG,"SAL1_bt_modo_op");
       GtkWidget *frame_req = glade_xml_get_widget(xmlG,"Frame_SAL1_req");
       GtkWidget *frame_table_Q = glade_xml_get_widget(xmlG,"Frame_SAL1_learn_Q");
       GtkWidget *bt_learn_begin = glade_xml_get_widget(xmlG,"SAL1_bt_learn_begin");
       GtkWidget *bt_learning = glade_xml_get_widget(xmlG,"SAL1_bt_learning");
       GtkWidget *action_img = glade_xml_get_widget(xmlG,"SAL1_mov_img");
       GtkWidget *bt_ligar = glade_xml_get_widget(xmlG,"SAL1_bt_ligar");
       GtkWidget *lbl_modo_op = glade_xml_get_widget(xmlG,"SAL1_lbl_modo_op");
       
       switch(EstadoG.SAL1.Modo_op)
       {
	      case Autonomo:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,TRUE);
		     
		     sprintf(lbl_mode,"Autonomo");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");

		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Manual:
		     gtk_widget_set_sensitive(frame_table_Q,TRUE);
		     gtk_widget_set_sensitive(frame_req,TRUE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,TRUE);
		     
		     sprintf(lbl_mode,"Manual");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"AUTONOMO");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Learning:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,FALSE);
		     
		     sprintf(lbl_mode,"Learning");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Idle:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,FALSE);
		     gtk_widget_set_sensitive(bt_learn_begin,FALSE);
		     gtk_widget_set_sensitive(bt_learning,FALSE);
		     
		     sprintf(lbl_mode,"Idle");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_CONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
       }
       
       gtk_image_set_from_pixbuf(GTK_IMAGE(action_img),SALbot_mov_pixbufG.no_mov);
}

/** 
*  @fn void Actualiza_estado_SAL2(void)
*  Função que actualiza na interface os widgets activos para o estado actual do SALbot1
*/
void Actualiza_estado_SAL2(void)
{
       char lbl_mode[30];
       GtkWidget *bt_modo = glade_xml_get_widget(xmlG,"SAL2_bt_modo_op");
       GtkWidget *frame_req = glade_xml_get_widget(xmlG,"Frame_SAL2_req");
       GtkWidget *frame_table_Q = glade_xml_get_widget(xmlG,"Frame_SAL2_learn_Q");
       GtkWidget *bt_learn_begin = glade_xml_get_widget(xmlG,"SAL2_bt_learn_begin");
       GtkWidget *bt_learning = glade_xml_get_widget(xmlG,"SAL2_bt_learning");
       GtkWidget *action_img = glade_xml_get_widget(xmlG,"SAL2_mov_img");
       GtkWidget *bt_ligar = glade_xml_get_widget(xmlG,"SAL2_bt_ligar");
       GtkWidget *lbl_modo_op = glade_xml_get_widget(xmlG,"SAL2_lbl_modo_op");
       
       switch(EstadoG.SAL2.Modo_op)
       {
	      case Autonomo:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,TRUE);
		     
		     sprintf(lbl_mode,"Autonomo");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Manual:
		     gtk_widget_set_sensitive(frame_table_Q,TRUE);
		     gtk_widget_set_sensitive(frame_req,TRUE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,TRUE);
		     
		     sprintf(lbl_mode,"Manual");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"AUTONOMO");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Learning:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,TRUE);
		     gtk_widget_set_sensitive(bt_learn_begin,TRUE);
		     gtk_widget_set_sensitive(bt_learning,FALSE);
		     
		     sprintf(lbl_mode,"Learning");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_DISCONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
	      case Idle:
		     gtk_widget_set_sensitive(frame_table_Q,FALSE);
		     gtk_widget_set_sensitive(frame_req,FALSE);
		     gtk_widget_set_sensitive(bt_modo,FALSE);
		     gtk_widget_set_sensitive(bt_learn_begin,FALSE);
		     gtk_widget_set_sensitive(bt_learning,FALSE);
		     
		     sprintf(lbl_mode,"Idle");
		     gtk_label_set_text((GtkLabel *)lbl_modo_op,  lbl_mode);
		     
		     gtk_button_set_label(GTK_BUTTON(bt_modo),"MANUAL");
		     
		     gtk_button_set_label(GTK_BUTTON(bt_ligar),GTK_STOCK_CONNECT);
		     gtk_button_set_use_stock(GTK_BUTTON(bt_ligar),TRUE);
		     break;
       }
       
       gtk_image_set_from_pixbuf(GTK_IMAGE(action_img),SALbot_mov_pixbufG.no_mov);
}

/**
* @fn Actualiza_lbl_SAL1(void)
* Função que actualiza as variáveis do \b SALbot2 contidas na interface gráfica.
*/
void Actualiza_lbl_SAL1(void)
{       
       char lbl_IR_F_dist[30], lbl_IR_B_dist[30], lbl_IR_L_dist[30], lbl_IR_R_dist[30], lbl_US_F_dist[30];
       char lbl_IR_F_val[30], lbl_IR_B_val[30], lbl_IR_L_val[30], lbl_IR_R_val[30], lbl_US_F_val[30];
       char lbl_IR_F_level[2], lbl_IR_B_level[2], lbl_IR_L_level[2], lbl_IR_R_level[2], lbl_US_F_level[2];
       
       GtkWidget *lbl_txt_IR_F_dist, *lbl_txt_IR_B_dist, *lbl_txt_IR_L_dist, *lbl_txt_IR_R_dist, *lbl_txt_US_F_dist;
       GtkWidget *lbl_txt_IR_F_val, *lbl_txt_IR_B_val, *lbl_txt_IR_L_val, *lbl_txt_IR_R_val, *lbl_txt_US_F_val;
       GtkWidget *lbl_txt_IR_F_level, *lbl_txt_IR_B_level, *lbl_txt_IR_L_level, *lbl_txt_IR_R_level, *lbl_txt_US_F_level;

       lbl_txt_IR_F_dist = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_F_dist");
       lbl_txt_IR_B_dist = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_B_dist");
       lbl_txt_IR_L_dist = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_L_dist");
       lbl_txt_IR_R_dist = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_R_dist");
       lbl_txt_US_F_dist = glade_xml_get_widget(xmlG, "SAL1_lbl_US_F_dist");
       
       lbl_txt_IR_F_val = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_F_val");
       lbl_txt_IR_B_val = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_B_val");
       lbl_txt_IR_L_val = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_L_val");
       lbl_txt_IR_R_val = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_R_val");
       lbl_txt_US_F_val = glade_xml_get_widget(xmlG, "SAL1_lbl_US_F_val");
       
       lbl_txt_IR_F_level = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_F_level");
       lbl_txt_IR_B_level = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_B_level");
       lbl_txt_IR_L_level = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_L_level");
       lbl_txt_IR_R_level = glade_xml_get_widget(xmlG, "SAL1_lbl_IR_R_level");
       lbl_txt_US_F_level = glade_xml_get_widget(xmlG, "SAL1_lbl_US_F_level");
        
       if(EstadoG.SAL1.IR_F.val<66 || EstadoG.SAL1.IR_F.val>717)
       {
	      sprintf(lbl_IR_F_dist,"??? %f mm",EstadoG.SAL1.IR_F.dist);
       }
       else
       {
	      sprintf(lbl_IR_F_dist,"%f mm",EstadoG.SAL1.IR_F.dist);
       }  
       if(EstadoG.SAL1.IR_B.val<66 || EstadoG.SAL1.IR_B.val>717)
       {
	      sprintf(lbl_IR_B_dist,"??? %f mm",EstadoG.SAL1.IR_B.dist);
       }
       else
       {
	      sprintf(lbl_IR_B_dist,"%f mm",EstadoG.SAL1.IR_B.dist);
       }  
       if(EstadoG.SAL1.IR_L.val<66 || EstadoG.SAL1.IR_L.val>717)
       {
	      sprintf(lbl_IR_L_dist,"??? %f mm",EstadoG.SAL1.IR_L.dist);
       }
       else
       {
	      sprintf(lbl_IR_L_dist,"%f mm",EstadoG.SAL1.IR_L.dist);
       }  
       if(EstadoG.SAL1.IR_R.val<66 || EstadoG.SAL1.IR_R.val>717)
       {
	      sprintf(lbl_IR_R_dist,"??? %f mm",EstadoG.SAL1.IR_R.dist);
       }
       else
       {
	      sprintf(lbl_IR_R_dist,"%f mm",EstadoG.SAL1.IR_R.dist);
       }
       sprintf(lbl_US_F_dist,"%f mm",EstadoG.SAL1.US_F.dist);
      
       sprintf(lbl_IR_F_val,"%d",EstadoG.SAL1.IR_F.val);
       sprintf(lbl_IR_B_val,"%d",EstadoG.SAL1.IR_B.val);
       sprintf(lbl_IR_L_val,"%d",EstadoG.SAL1.IR_L.val);
       sprintf(lbl_IR_R_val,"%d",EstadoG.SAL1.IR_R.val);
       sprintf(lbl_US_F_val,"%d",EstadoG.SAL1.US_F.val);
       
       sprintf(lbl_IR_F_level,"%d",EstadoG.SAL1.IR_F.level);
       sprintf(lbl_IR_B_level,"%d",EstadoG.SAL1.IR_B.level);
       sprintf(lbl_IR_L_level,"%d",EstadoG.SAL1.IR_L.level);
       sprintf(lbl_IR_R_level,"%d",EstadoG.SAL1.IR_R.level);
       sprintf(lbl_US_F_level,"%d",EstadoG.SAL1.US_F.level);
       
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_dist, lbl_IR_F_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_dist, lbl_IR_B_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_dist, lbl_IR_L_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_dist, lbl_IR_R_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_dist, lbl_US_F_dist);
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_val, lbl_IR_F_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_val, lbl_IR_B_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_val, lbl_IR_L_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_val, lbl_IR_R_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_val, lbl_US_F_val);
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_level, lbl_IR_F_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_level, lbl_IR_B_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_level, lbl_IR_L_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_level, lbl_IR_R_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_level, lbl_US_F_level);
       
}

/**
* @fn Actualiza_lbl_SAL2(void)
* Função que actualiza as variáveis do \b SALbot2 contidas na interface gráfica.
*/
void Actualiza_lbl_SAL2(void)
{       
       char lbl_IR_F_dist[30], lbl_IR_B_dist[30], lbl_IR_L_dist[30], lbl_IR_R_dist[30], lbl_US_F_dist[30];
       char lbl_IR_F_val[30], lbl_IR_B_val[30], lbl_IR_L_val[30], lbl_IR_R_val[30], lbl_US_F_val[30];
       char lbl_IR_F_level[2], lbl_IR_B_level[2], lbl_IR_L_level[2], lbl_IR_R_level[2], lbl_US_F_level[2];
       
       GtkWidget *lbl_txt_IR_F_dist, *lbl_txt_IR_B_dist, *lbl_txt_IR_L_dist, *lbl_txt_IR_R_dist, *lbl_txt_US_F_dist;
       GtkWidget *lbl_txt_IR_F_val, *lbl_txt_IR_B_val, *lbl_txt_IR_L_val, *lbl_txt_IR_R_val, *lbl_txt_US_F_val;
       GtkWidget *lbl_txt_IR_F_level, *lbl_txt_IR_B_level, *lbl_txt_IR_L_level, *lbl_txt_IR_R_level, *lbl_txt_US_F_level;
       
       lbl_txt_IR_F_dist = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_F_dist");
       lbl_txt_IR_B_dist = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_B_dist");
       lbl_txt_IR_L_dist = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_L_dist");
       lbl_txt_IR_R_dist = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_R_dist");
       lbl_txt_US_F_dist = glade_xml_get_widget(xmlG, "SAL2_lbl_US_F_dist");
       
       lbl_txt_IR_F_val= glade_xml_get_widget(xmlG, "SAL2_lbl_IR_F_val");
       lbl_txt_IR_B_val = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_B_val");
       lbl_txt_IR_L_val = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_L_val");
       lbl_txt_IR_R_val = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_R_val");
       lbl_txt_US_F_val = glade_xml_get_widget(xmlG, "SAL2_lbl_US_F_val");
       
       lbl_txt_IR_F_level= glade_xml_get_widget(xmlG, "SAL2_lbl_IR_F_level");
       lbl_txt_IR_B_level = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_B_level");
       lbl_txt_IR_L_level = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_L_level");
       lbl_txt_IR_R_level = glade_xml_get_widget(xmlG, "SAL2_lbl_IR_R_level");
       lbl_txt_US_F_level = glade_xml_get_widget(xmlG, "SAL2_lbl_US_F_level");
       
       if(EstadoG.SAL2.IR_F.val<66 || EstadoG.SAL2.IR_F.val>717)
       {
	      sprintf(lbl_IR_F_dist,"??? %f mm",EstadoG.SAL2.IR_F.dist);
       }
       else
       {
	      sprintf(lbl_IR_F_dist,"%f mm",EstadoG.SAL2.IR_F.dist);
       }  
       if(EstadoG.SAL2.IR_B.val<66 || EstadoG.SAL2.IR_B.val>717)
       {
	      sprintf(lbl_IR_B_dist,"??? %f mm",EstadoG.SAL2.IR_B.dist);
       }
       else
       {
	      sprintf(lbl_IR_B_dist,"%f mm",EstadoG.SAL2.IR_B.dist);
       }  
       if(EstadoG.SAL2.IR_L.val<66 || EstadoG.SAL2.IR_L.val>717)
       {
	      sprintf(lbl_IR_L_dist,"??? %f mm",EstadoG.SAL2.IR_L.dist);
       }
       else
       {
	      sprintf(lbl_IR_L_dist,"%f mm",EstadoG.SAL2.IR_L.dist);
       }  
       if(EstadoG.SAL2.IR_R.val<66 || EstadoG.SAL2.IR_R.val>717)
       {
	      sprintf(lbl_IR_R_dist,"??? %f mm",EstadoG.SAL2.IR_R.dist);
       }
       else
       {
	      sprintf(lbl_IR_R_dist,"%f mm",EstadoG.SAL2.IR_R.dist);
       }
       sprintf(lbl_US_F_dist,"%f mm",EstadoG.SAL2.US_F.dist);
       
       sprintf(lbl_IR_F_val,"%d",EstadoG.SAL2.IR_F.val);
       sprintf(lbl_IR_B_val,"%d",EstadoG.SAL2.IR_B.val);
       sprintf(lbl_IR_L_val,"%d",EstadoG.SAL2.IR_L.val);
       sprintf(lbl_IR_R_val,"%d",EstadoG.SAL2.IR_R.val);
       sprintf(lbl_US_F_val,"%d",EstadoG.SAL2.US_F.val);
       
       sprintf(lbl_IR_F_level,"%d",EstadoG.SAL2.IR_F.level);
       sprintf(lbl_IR_B_level,"%d",EstadoG.SAL2.IR_B.level);
       sprintf(lbl_IR_L_level,"%d",EstadoG.SAL2.IR_L.level);
       sprintf(lbl_IR_R_level,"%d",EstadoG.SAL2.IR_R.level);
       sprintf(lbl_US_F_level,"%d",EstadoG.SAL2.US_F.level);
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_dist, lbl_IR_F_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_dist, lbl_IR_B_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_dist, lbl_IR_L_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_dist, lbl_IR_R_dist);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_dist, lbl_US_F_dist);
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_val, lbl_IR_F_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_val, lbl_IR_B_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_val, lbl_IR_L_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_val, lbl_IR_R_val);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_val, lbl_US_F_val);
       
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_F_level, lbl_IR_F_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_B_level, lbl_IR_B_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_L_level, lbl_IR_L_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_IR_R_level, lbl_IR_R_level);
       gtk_entry_set_text((GtkEntry *)lbl_txt_US_F_level, lbl_US_F_level);
}

/**
* @fn Actualiza_img_SAL1(void)
* Função que actualiza a imagem dos para-choques do  \b SALbot1 representado na interface gráfica.
*/
void Actualiza_img_SAL1(void)
{
       GtkWidget *img_Front_left = glade_xml_get_widget(xmlG,"SALbot1_front_left");
       GtkWidget *img_Front_right = glade_xml_get_widget(xmlG,"SALbot1_front_right");
       GtkWidget *img_Left_front = glade_xml_get_widget(xmlG,"SALbot1_left_front");
       GtkWidget *img_Right_front = glade_xml_get_widget(xmlG,"SALbot1_right_front");
       GtkWidget *img_Left = glade_xml_get_widget(xmlG,"SALbot1_left");
       GtkWidget *img_Right = glade_xml_get_widget(xmlG,"SALbot1_right");
       GtkWidget *img_Back_left = glade_xml_get_widget(xmlG,"SALbot1_back_left");
       GtkWidget *img_Back_right = glade_xml_get_widget(xmlG,"SALbot1_back_right");
       
       if(EstadoG.SAL1.Bumper.front_left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_left),SALbot_bumper_pixbufG.Front_left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_left),SALbot_bumper_pixbufG.Front_left.closed);
       }
       if(EstadoG.SAL1.Bumper.front_right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_right),SALbot_bumper_pixbufG.Front_right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_right),SALbot_bumper_pixbufG.Front_right.closed);
       }
       if(EstadoG.SAL1.Bumper.left_front == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left_front),SALbot_bumper_pixbufG.Left_front.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left_front),SALbot_bumper_pixbufG.Left_front.closed);
       }
       if(EstadoG.SAL1.Bumper.right_front == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right_front),SALbot_bumper_pixbufG.Right_front.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right_front),SALbot_bumper_pixbufG.Right_front.closed);
       }
       if(EstadoG.SAL1.Bumper.left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left),SALbot_bumper_pixbufG.Left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left),SALbot_bumper_pixbufG.Left.closed);
       }
       if(EstadoG.SAL1.Bumper.right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right),SALbot_bumper_pixbufG.Right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right),SALbot_bumper_pixbufG.Right.closed);
       }
       if(EstadoG.SAL1.Bumper.back_left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_left),SALbot_bumper_pixbufG.Back_left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_left),SALbot_bumper_pixbufG.Back_left.closed);
       }
       if(EstadoG.SAL1.Bumper.back_right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_right),SALbot_bumper_pixbufG.Back_right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_right),SALbot_bumper_pixbufG.Back_right.closed);
       }
       GtkWidget *note_book = glade_xml_get_widget(xmlG,"notebook1");
       GdkWindow *win = gtk_widget_get_parent_window(note_book);
       gdk_window_invalidate_rect(win,NULL,TRUE);
}

/**
* @fn Actualiza_img_SAL2(void)
* Função que actualiza a imagem dos para-choques do  \b SALbot2 representado na interface gráfica.
*/
void Actualiza_img_SAL2(void)
{
       GtkWidget *img_Front_left = glade_xml_get_widget(xmlG,"SALbot2_front_left");
       GtkWidget *img_Front_right = glade_xml_get_widget(xmlG,"SALbot2_front_right");
       GtkWidget *img_Left_front = glade_xml_get_widget(xmlG,"SALbot2_left_front");
       GtkWidget *img_Right_front = glade_xml_get_widget(xmlG,"SALbot2_right_front");
       GtkWidget *img_Left = glade_xml_get_widget(xmlG,"SALbot2_left");
       GtkWidget *img_Right = glade_xml_get_widget(xmlG,"SALbot2_right");
       GtkWidget *img_Back_left = glade_xml_get_widget(xmlG,"SALbot2_back_left");
       GtkWidget *img_Back_right = glade_xml_get_widget(xmlG,"SALbot2_back_right");
       
       if(EstadoG.SAL2.Bumper.front_left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_left),SALbot_bumper_pixbufG.Front_left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_left),SALbot_bumper_pixbufG.Front_left.closed);
       }
       if(EstadoG.SAL2.Bumper.front_right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_right),SALbot_bumper_pixbufG.Front_right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Front_right),SALbot_bumper_pixbufG.Front_right.closed);
       }
       if(EstadoG.SAL2.Bumper.left_front == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left_front),SALbot_bumper_pixbufG.Left_front.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left_front),SALbot_bumper_pixbufG.Left_front.closed);
       }
       if(EstadoG.SAL2.Bumper.right_front == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right_front),SALbot_bumper_pixbufG.Right_front.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right_front),SALbot_bumper_pixbufG.Right_front.closed);
       }
       if(EstadoG.SAL2.Bumper.left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left),SALbot_bumper_pixbufG.Left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Left),SALbot_bumper_pixbufG.Left.closed);
       }
       if(EstadoG.SAL2.Bumper.right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right),SALbot_bumper_pixbufG.Right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Right),SALbot_bumper_pixbufG.Right.closed);
       }
       if(EstadoG.SAL2.Bumper.back_left == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_left),SALbot_bumper_pixbufG.Back_left.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_left),SALbot_bumper_pixbufG.Back_left.closed);
       }
       if(EstadoG.SAL2.Bumper.back_right == 0)
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_right),SALbot_bumper_pixbufG.Back_right.open);
       }
       else
       {
	      gtk_image_set_from_pixbuf(GTK_IMAGE(img_Back_right),SALbot_bumper_pixbufG.Back_right.closed);
       }
       GtkWidget *note_book = glade_xml_get_widget(xmlG,"notebook1");
       GdkWindow *win = gtk_widget_get_parent_window(note_book);
       gdk_window_invalidate_rect(win,NULL,TRUE);
}

/**
 * @fn void Actualiza_graph_SAL1(void)
 * Função que actualiza o gráfico da Aprendizagem do SAL1
 */
void Actualiza_graph_SAL1(void)
{
       GtkWidget *box;
       GtkWidget *boxcontainer;
       GtkDataboxGraph *graph;
       gfloat min_x, max_x, min_y, max_y;
       GdkColor cor;
       unsigned int i;
       
       /* Actualiza Databox */
       
       box = DataBoxG.SAL1_box;
       boxcontainer = DataBoxG.SAL1_boxcontainer;
       
       if(EstadoG.SAL1.Learn_iteration == 2)
       {
	      /* Criar gráficos */
	      
	      cor.red = 46260;
	      cor.green = 7710;
	      cor.blue = 0;
	      
	      graph = gtk_databox_lines_new(65535,EstadoG.SAL1.X,EstadoG.SAL1.Y,&cor,1);
	      gtk_databox_graph_add(GTK_DATABOX(DataBoxG.SAL1_box),graph);
	      g_signal_connect(GTK_OBJECT(DataBoxG.SAL1_box),"key_press_event",G_CALLBACK(SAL1_key_pressed),graph);
       }
              
       if(EstadoG.SAL1.Learn_iteration)
       {
	      for(i=0;i<65535;i++)
	      {
		     if(EstadoG.SAL1.Learn_iteration > i)
		     {
			    EstadoG.SAL1.X[i] = i;
			    EstadoG.SAL1.Y[i] = EstadoG.SAL1.Learn_progress[i];
		     }
		     else
		     {
			    EstadoG.SAL1.X[i] = EstadoG.SAL1.Learn_iteration;
			    EstadoG.SAL1.Y[i] = EstadoG.SAL1.Learn_progress[EstadoG.SAL1.Learn_iteration];
		     }
	      }
       }
       
       if(EstadoG.SAL1.Learn_iteration >= 2)
       {	      
	      if(EstadoG.SAL1.Learn_iteration > DataBoxG.SAL1_max_x)
	      {
		     gtk_databox_get_total_limits(GTK_DATABOX(box),&min_x,&max_x,&max_y,&min_y);
		     
		     max_x += 100;
		     DataBoxG.SAL1_max_x +=100;
		     
		     DataBoxG.SAL1_view.minv_x = max_x-115;
		     DataBoxG.SAL1_view.maxv_x = max_x-5;
		     DataBoxG.SAL1_view.minv_y = max_y-115;
		     DataBoxG.SAL1_view.maxv_y = max_y-5;
		     
		     gtk_databox_set_total_limits(GTK_DATABOX(box),min_x,max_x,max_y,min_y);
		     gtk_databox_set_visible_limits(GTK_DATABOX(box),DataBoxG.SAL1_view.minv_x,DataBoxG.SAL1_view.maxv_x,DataBoxG.SAL1_view.maxv_y,DataBoxG.SAL1_view.minv_y);
	      }
	      if(EstadoG.SAL1.Learn_progress[EstadoG.SAL1.Learn_iteration] > DataBoxG.SAL1_max_y)
	      {
		    gtk_databox_get_total_limits(GTK_DATABOX(box),&min_x,&max_x,&max_y,&min_y);
		    
		    max_y += 100;
		    DataBoxG.SAL1_max_y +=100;
		    
		    DataBoxG.SAL1_view.minv_x = max_x-115;
		    DataBoxG.SAL1_view.maxv_x = max_x-5;
		    DataBoxG.SAL1_view.minv_y = max_y-115;
		    DataBoxG.SAL1_view.maxv_y = max_y-5;
			    
		    gtk_databox_set_total_limits(GTK_DATABOX(box),min_x,max_x,max_y,min_y);
		    gtk_databox_set_visible_limits(GTK_DATABOX(box),DataBoxG.SAL1_view.minv_x,DataBoxG.SAL1_view.maxv_x,DataBoxG.SAL1_view.maxv_y,DataBoxG.SAL1_view.minv_y);
	      }
	      gtk_widget_queue_draw (GTK_WIDGET (box));
       }
}

/**
* @fn void Actualiza_graph_SAL2(void)
* Função que actualiza o gráfico da Aprendizagem do SAL2
*/
void Actualiza_graph_SAL2(void)
{
       GtkWidget *box;
       GtkWidget *boxcontainer;
       GtkDataboxGraph *graph;
       gfloat min_x, max_x, min_y, max_y;
       GdkColor cor;
       unsigned int i;
       
       /* Actualiza Databox */
       
       box = DataBoxG.SAL2_box;
       boxcontainer = DataBoxG.SAL2_boxcontainer;
       
       if(EstadoG.SAL2.Learn_iteration == 2)
       {
	      /* Criar gráficos */
	      
	      cor.red = 10280;
	      cor.green = 12850;
	      cor.blue = 56540;
	      
	      graph = gtk_databox_lines_new(65535,EstadoG.SAL2.X,EstadoG.SAL2.Y,&cor,1);
	      gtk_databox_graph_add(GTK_DATABOX(DataBoxG.SAL2_box),graph);
	      g_signal_connect(GTK_OBJECT(DataBoxG.SAL2_box),"key_press_event",G_CALLBACK(SAL2_key_pressed),graph);  
       }
       
       if(EstadoG.SAL2.Learn_iteration)
       {
	      for(i=0;i<65535;i++)
	      {
		     if(EstadoG.SAL2.Learn_iteration > i)
		     {
			    EstadoG.SAL2.X[i] = i;
			    EstadoG.SAL2.Y[i] = EstadoG.SAL2.Learn_progress[i];
		     }
		     else
		     {
			    EstadoG.SAL2.X[i] = EstadoG.SAL2.Learn_iteration;
			    EstadoG.SAL2.Y[i] = EstadoG.SAL2.Learn_progress[EstadoG.SAL2.Learn_iteration];
		     }
	      }
       }
       
       if(EstadoG.SAL2.Learn_iteration >= 2)
       {	      
	      if(EstadoG.SAL2.Learn_iteration > DataBoxG.SAL2_max_x)
	      {
		     gtk_databox_get_total_limits(GTK_DATABOX(box),&min_x,&max_x,&max_y,&min_y);
		     
		     max_x += 100;
		     DataBoxG.SAL2_max_x +=100;
		     
		     DataBoxG.SAL2_view.minv_x = max_x-115;
		     DataBoxG.SAL2_view.maxv_x = max_x-5;
		     DataBoxG.SAL2_view.minv_y = max_y-115;
		     DataBoxG.SAL2_view.maxv_y = max_y-5;
		     
		     gtk_databox_set_total_limits(GTK_DATABOX(box),min_x,max_x,max_y,min_y);
		     gtk_databox_set_visible_limits(GTK_DATABOX(box),DataBoxG.SAL2_view.minv_x,DataBoxG.SAL2_view.maxv_x,DataBoxG.SAL2_view.maxv_y,DataBoxG.SAL2_view.minv_y);
	      }
	      if(EstadoG.SAL2.Learn_progress[EstadoG.SAL2.Learn_iteration] > DataBoxG.SAL2_max_y)
	      {
		     gtk_databox_get_total_limits(GTK_DATABOX(box),&min_x,&max_x,&max_y,&min_y);
		     
		     max_y += 100;
		     DataBoxG.SAL2_max_y +=100;
		     
		     DataBoxG.SAL2_view.minv_x = max_x-115;
		     DataBoxG.SAL2_view.maxv_x = max_x-5;
		     DataBoxG.SAL2_view.minv_y = max_y-115;
		     DataBoxG.SAL2_view.maxv_y = max_y-5;
		     
		     gtk_databox_set_total_limits(GTK_DATABOX(box),min_x,max_x,max_y,min_y);
		     gtk_databox_set_visible_limits(GTK_DATABOX(box),DataBoxG.SAL2_view.minv_x,DataBoxG.SAL2_view.maxv_x,DataBoxG.SAL2_view.maxv_y,DataBoxG.SAL2_view.minv_y);
	      }
	      gtk_widget_queue_draw (GTK_WIDGET (box));
       }
}

/**
*@fn void Actualiza_img_action_SAL1(void)
* Função que actualiza a imagem correspondente ao movimento do SALbot1
*/
void Actualiza_img_action_SAL1(void)
{
       GtkWidget *mov_img = glade_xml_get_widget(xmlG,"SAL1_mov_img");
       
       switch(EstadoG.SAL1.Action)
       {
	      case 0:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_front);
		     break;
	      case 1:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_f);
		     break;
	      case 2:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_left_f);
		     break;
	      case 3:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.turn_right);
		     break;
	      case 4:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.turn_left);
		     break;
	      case 5:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_back);
		     break;
	      /*case 6:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_f);
		     break;
	      case 7:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_b);
		     break;
	      case 8:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_left_b);
		     break;*/
       }
       GtkWidget *note_book = glade_xml_get_widget(xmlG,"notebook1");
       GdkWindow *win = gtk_widget_get_parent_window(note_book);
       gdk_window_invalidate_rect(win,NULL,TRUE);
}

/**
*@fn void Actualiza_img_action_SAL2(void)
* Função que actualiza a imagem correspondente ao movimento do SALbot1
*/
void Actualiza_img_action_SAL2(void)
{
       GtkWidget *mov_img = glade_xml_get_widget(xmlG,"SAL2_mov_img");
       
       switch(EstadoG.SAL2.Action)
       {
	      case 0:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_front);
		     break;
	      case 1:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_f);
		     break;
	      case 2:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_left_f);
		     break;
	      case 3:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.turn_right);
		     break;
	      case 4:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.turn_left);
		     break;
	      case 5:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_back);
		     break;
	      /*case 6:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_f);
		     break;
	      case 7:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_right_b);
		     break;
	      case 8:
		     gtk_image_set_from_pixbuf(GTK_IMAGE(mov_img),SALbot_mov_pixbufG.mov_left_b);
		     break;*/
       }
       GtkWidget *note_book = glade_xml_get_widget(xmlG,"notebook1");
       GdkWindow *win = gtk_widget_get_parent_window(note_book);
       gdk_window_invalidate_rect(win,NULL,TRUE);
}

/**
 * @fn void load_dialog(int SALn)
 * Função que abre uma janela de dialogo para carregar um ficheiro de tabela de aprendizagem
 */
void load_dialog(int SALn)
{
       GtkWidget *parent_window = gtk_window_new(GTK_WINDOW_POPUP);
       GtkWidget *dialog;
       
       const gchar*  default_folder_for_opening = "Save/Table/";
       GtkFileFilter* csv_filter = gtk_file_filter_new();
       gtk_file_filter_add_pattern(csv_filter, "*.csv");
       
       mkdir("Save",0777);
       mkdir("Save/Table",0777);
       
       dialog = gtk_file_chooser_dialog_new ("Abrir ficheiro de Tabela de Aprendizagem",
					      (GtkWindow *)parent_window,
					      GTK_FILE_CHOOSER_ACTION_OPEN,
					      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
					      NULL);

       gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
       gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), default_folder_for_opening);

       if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
       {
	   char *filename;
	   
	   filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	   
	   carrega_dados(filename,SALn);
	   g_free (filename);
       }
       gtk_widget_destroy (dialog);
}

/**
* @fn void save_dialog(int SALn)
* Função que abre uma janela de dialogo para guardar um ficheiro de tabela de aprendizagem
*/
void save_dialog(int SALn)
{
       GtkWidget *parent_window = gtk_window_new(GTK_WINDOW_POPUP);
       GtkWidget *dialog;
       const gchar*  default_folder_for_saving = "Save/Table/";
       const gchar* filename_for_existing_document = "Save/Table/Q_table.csv";
       GtkFileFilter* csv_filter = gtk_file_filter_new();
       gtk_file_filter_add_pattern(csv_filter, "*.csv");
       
       mkdir("Save",0777);
       mkdir("Save/Table",0777);
       
       dialog = gtk_file_chooser_dialog_new ("Guardar ficheiro de Tabela de Aprendizagem",
					      (GtkWindow *)parent_window,
					      GTK_FILE_CHOOSER_ACTION_SAVE,
					      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
					      NULL);

       gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog), TRUE);
       if (1)
       {
	   gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
	   gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), default_folder_for_saving);
	   gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), "SAL_Q_.csv");
       }
       else
       {
	   gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
	   gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (dialog), filename_for_existing_document);
       }
       if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
       {
	   char *filename;
	   
	   filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	   
	   guarda_dados(filename,SALn);
	   g_free (filename);
       }
       gtk_widget_destroy (dialog);
}

/**
 * @fn void save_pgr_dialog(int SALn)
 * Função que abre uma janela de dialogo para guardar um ficheiro da progressão de aprendizagem
 */
void save_pgr_dialog(int SALn)
{
       GtkWidget *parent_window = gtk_window_new(GTK_WINDOW_POPUP);
       GtkWidget *dialog;
       const gchar*  default_folder_for_saving = "Save/PGR/";
       const gchar* filename_for_existing_document = "Save/PGR/learn_pgr.csv";
       GtkFileFilter* csv_filter = gtk_file_filter_new();
       gtk_file_filter_add_pattern(csv_filter, "*.csv");
       
       mkdir("Save",0777);
       mkdir("Save/PGR",0777);
       
       dialog = gtk_file_chooser_dialog_new ("Guardar ficheiro de Progressão de Aprendizagem",
					      (GtkWindow *)parent_window,
					      GTK_FILE_CHOOSER_ACTION_SAVE,
					      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
					      NULL);
					      
       gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog), TRUE);
       if (1)
       {
	   gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
	   gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), default_folder_for_saving);
	   gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), "SAL_pgr_.csv");
       }
       else
       {
	   gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
	   gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (dialog), filename_for_existing_document);
       }
       if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
       {
	   char *filename;
	   
	   filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	   
	   guarda_dados_pgr(filename,SALn);
	   g_free (filename);
       }
       gtk_widget_destroy (dialog);
}

/**
* @fn void load_pgr_dialog(int SALn)
* Função que abre uma janela de dialogo para Carregar um ficheiro com a progressão de aprendizagem
*/
void load_pgr_dialog(int SALn)
{
       GtkWidget *parent_window = gtk_window_new(GTK_WINDOW_POPUP);
       GtkWidget *dialog;
       
       const gchar*  default_folder_for_opening = "Save/PGR/";
       GtkFileFilter* csv_filter = gtk_file_filter_new();
       gtk_file_filter_add_pattern(csv_filter, "*.csv");
       
       mkdir("Save",0777);
       mkdir("Save/PGR",0777);
       
       dialog = gtk_file_chooser_dialog_new ("Abrir ficheiro de Progressão de Aprendizagem",
					      (GtkWindow *)parent_window,
					      GTK_FILE_CHOOSER_ACTION_OPEN,
					      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
					      NULL);

       gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (dialog), csv_filter);
       gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (dialog), default_folder_for_opening);

       if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
       {
	   char *filename;
	   
	   filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
	   
	   carrega_dados_pgr(filename,SALn);
	   g_free (filename);
       }
       gtk_widget_destroy (dialog);
}

/**
* @fn void guarda_dados (gchar *path)
* Função que guarda as tabelas de aprendizagem dos SALbot.
*/
void guarda_dados (gchar *path, int SAL_n)
{
       int a,s;
       FILE *ficheiro = fopen(path,"w");
       
       printf("\nEscrevendo no ficheiro\n");
       
       fprintf(ficheiro,"\"Estados\\Acções\" ,1,2,3,4,5,6");
       
       switch(SAL_n)
       {
	      case 1:
		     for(s=0;s<Num_states_;s++)
		     {
			    fprintf(ficheiro,"\n%d",s);
			    for(a=0;a<Num_actions_;a++)
			    {
				   fprintf(ficheiro,",%d",EstadoG.SAL1.Q_table[a][s]);
			    }
		     }
		     break;
	      case 2:
		     for(s=0;s<Num_states_;s++)
		     {
			    fprintf(ficheiro,"\n%d",s);
			    for(a=0;a<Num_actions_;a++)
			    {
				   fprintf(ficheiro,",%d",EstadoG.SAL2.Q_table[a][s]);
			    }
		     }
		     break;
       }
       fclose(ficheiro);
       
       printf("\nFicheiro guardado.\n");
       return;
}

/**
* @fn void carrega_dados(gchar *path)
* Função que carrega as tabelas de aprendizagem dos SALbot.
*/
void carrega_dados(gchar *path, int SAL_n)
{
       unsigned int a,s,dummy,dummy2;
       FILE *ficheiro = fopen(path,"r");
       
       printf("\nLendo o ficheiro\n");
       
       fscanf(ficheiro,"\"Estados\\Acções\" ,1,2,3,4,5,6");
       
       switch(SAL_n)
       {
	      case 1:
		     for(s=0;s<Num_states_;s++)
		     {
			    fscanf(ficheiro,"\n%d",&dummy);
			    for(a=0;a<Num_actions_;a++)
			    {
				   fscanf(ficheiro,",%d",&dummy2);
				   EstadoG.SAL1.Q_table[a][s] = (signed char)dummy2;
			    }
		     }
		     break;
	      case 2:
		     for(s=0;s<Num_states_;s++)
		     {
			    fscanf(ficheiro,"\n%d",&dummy);
			    for(a=0;a<Num_actions_;a++)
			    {
				   fscanf(ficheiro,",%d",&dummy2);
				   EstadoG.SAL2.Q_table[a][s] = (signed char)dummy2;
			    }
		     }
		     break;
       }
       fclose(ficheiro);
       
       printf("\nFicheiro aberto.\n");
}

/**
* @fn void guarda_dados_pgr(gchar *path)
* Função que guarda os dados da progressão de aprendizagem dos SALbot.
*/
void guarda_dados_pgr(gchar *path, int SAL_n)
{
       int a,s;
       unsigned int Iteration;
       FILE *ficheiro = fopen(path,"w");
       
       printf("\nEscrevendo a progressão de aprendizagem no ficheiro\n");
       
       switch(SAL_n)
       {
	      case 1:
		     Iteration = EstadoG.SAL1.Learn_iteration;
		     break;
	      case 2:
		     Iteration = EstadoG.SAL2.Learn_iteration;
		     break;
       }
       
       fprintf(ficheiro,"\"Número de Iterações\",%d,",Iteration);
       
       fprintf(ficheiro,"\n\"Iterações\",\"Colisões\",\"Epsilon\"");
       
       switch(SAL_n)
       {
	      case 1:
		     for(s=0;s<=EstadoG.SAL1.Learn_iteration;s++)
		     {
			    fprintf(ficheiro,"\n%d,%d,\"%f\"",s,EstadoG.SAL1.Learn_progress[s],EstadoG.SAL1.Learn_epsilon[s]);
		     }
		     break;
	      case 2:
		     for(s=0;s<=EstadoG.SAL2.Learn_iteration;s++)
		     {
			    fprintf(ficheiro,"\n%d,%d,\"%f\"",s,EstadoG.SAL2.Learn_progress[s],EstadoG.SAL2.Learn_epsilon[s]);
		     }
		     break;
       }
       fclose(ficheiro);
       
       printf("\nFicheiro de progressão de aprendizagem guardado.\n");
       return;
}

/**
* @fn void carrega_dados_pgr(gchar *path)
* Função que carrega os dados da progressão de aprendizagem dos SALbot.
*/
void carrega_dados_pgr(gchar *path, int SAL_n)
{
       int a,s,dummy;
       unsigned int Iteration;
       FILE *ficheiro = fopen(path,"r");
       
       printf("\nLendo o ficheiro de progressão de aprendizagem\n");
       
       fscanf(ficheiro,"\"Número de Iterações\",%d,",&Iteration);
       
       fscanf(ficheiro,"\n\"Iterações\",\"Colisões\",\"Epsilon\"");
       
       switch(SAL_n)
       {
	      case 1:
		     for(s=0;s<=Iteration;s++)
		     {
			    fscanf(ficheiro,"\n%d,%d,\"%f\"",&dummy,&EstadoG.SAL1.Learn_progress[s],&EstadoG.SAL1.Learn_epsilon[s]);
			    if (dummy > EstadoG.SAL1.Learn_iteration)
				   EstadoG.SAL1.Learn_iteration = dummy;
			    Actualiza_graph_SAL1();
		     }
		     break;
	      case 2:
		     for(s=0;s<=Iteration;s++)
		     {
			    fscanf(ficheiro,"\n%d,%d,\"%f\"",&dummy,&EstadoG.SAL2.Learn_progress[s],&EstadoG.SAL2.Learn_epsilon[s]);
			    if (dummy > EstadoG.SAL2.Learn_iteration)
				   EstadoG.SAL2.Learn_iteration = dummy;
			    Actualiza_graph_SAL2();
		     }
		     break;
       }
       fclose(ficheiro);
       
       printf("\nFicheiro de progressão de aprendizagem aberto.\n");
       
       return;
}
