/**
 * @file Fun.c
 * @author Hugo Tavares nº 27764 (hugo.tavares@ua.pt)
 * @brief Ficheiro que contém funções ou rotinas
 * 
 * Este ficheiro contém as funções e/ou rotinas que são chamadas por outros ficheiros
 */

#define _FUN_

#include "SALbot_Interface.h"

/**
 * @fn void header(void)
 * @brief Imprime um cabeçalho do programa
 * Imprime uma caixa de asteriscos com o nome da cadeira, o nome do trabalho de casa, 
 * o nome do programa e o autor.
 *
 */
void header(void)
{
	textcolor(RESET,BLUE,-30);
	printf("*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*\n");
	printf("*                                                                   *\n");
	printf("*                ");
	textcolor(RESET,RED,-30);
	printf("Laboratorio de Automação e Robótica                   ");
	textcolor(RESET,BLUE,-30);
	printf("*\n*                                                                   *\n");	
	printf("*                          ");
	textcolor(RESET,WHITE,BLUE);
	printf("SALbot Interface");
	textcolor(RESET,BLUE,-30);
	printf("                          *\n");
	printf("*                                                                   *\n");
	printf("*                             ");
	textcolor(RESET,CYAN,-30);
	printf("Via RS232");
	textcolor(RESET,BLUE,-30);
	printf("                             *\n");
	printf("*                                                                   *\n");
	printf("*               ");
	textcolor(RESET,GREEN,-30);
	printf("Hugo Emanuel Fonseca Tavares nº 27764               ");
	textcolor(RESET,BLUE,-30);
	printf("*\n*                                                                   *\n");
	printf("*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*\n\n");
	resetcolor();
}

/**
 * @fn void pausa(long a)
 * @brief Cria uma pausa
 *
 * Cria uma pausa de \a a milisegundos
 *
 * @param a valor dos milisegundos de pausa
 *
 */
void pausa(long a)
{
	struct timeval t1;
	struct timezone t2;
	long m1=0,m2=0; /**< \a m1 é igual aos segundos actuais + \a a microsegundos */
	gettimeofday(&t1,&t2);
	m1 = (t1.tv_sec)*1000 + (t1.tv_usec)/1000 + a; /**< \a m1 é igual aos segundos actuais + \a a microsegundos */
	
	do
	{
		gettimeofday(&t1,&t2);
		m2=(t1.tv_sec)*1000 + (t1.tv_usec)/1000; /**< \a m2 é igual aos segundos actuais em microsegundos */

	} while(m1 > m2);
}

/**
 * @fn void beep(void)
 * @brief Emite um sinal sonoro
 *
 * Emite um sinal sonoro
 */
void beep(void)
{
	printf("\a");
}
