/**
 * @file printline.c
 * @author Hugo Tavares nº 27764 (hugo.tavares@ua.pt)
 * @brief Ficheiro que contem funções de introdução de separadores
 * 
 * Este ficheiro contem funções que introduzem separadores em caracteres
 * no terminal de comando.
 */


#define _PRINT_

#include "SALbot_Interface.h"

/**
 * Imprime uma linha de asteriscos e traços para servir de separador
 */
void printline(void)
{
	textcolor(RESET,MAGENTA,-30);
	printf("\n*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*\n\n");
	resetcolor();
}

/**
 * Imprime uma linha que indica final do programa
 */
int printend(void)
{
	resetcolor();
	printf("\n*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-");
	textcolor(RESET,RED,YELLOW);
	printf("*-FIM-*");
	resetcolor();
	printf("-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*\n\n");

return 0;
}
