/**
 * @file textcolor.c
 * @author Hugo Tavares nº 27764 (hugo.tavares@ua.pt)
 * @brief Ficheiro que contém funções para mudar o texto do terminal
 * 
 * Este ficheiro contém funções que alteram o formato e cores (de fundo e texto)
 * do texto introduzido na linha de comandos do terminal.
 */


#define _TEXT_

#include "SALbot_Interface.h"

/**
 * Função textcolor que altera o formato do texto, a côr do texto e a côr de fundo.
 */
void textcolor(int atr, int ct, int cf)
{
printf("%c[%d;%d;%dm",0x1B,atr,ct+30,cf+40);
}

/**
 * Função para reiniciar a configuração do texto.
 */
void resetcolor(void)
{
	textcolor(0,-30,-40);
	printf("\033[K");
}
